// File:        Win32Serial.h
// Copyright:   (c) 2009 by Frydaysoft.de
// Author:      SFr (frydaysoft@gmx.de)
// Proj:        light visualization plugin (winamp)
// Short Info:  Basic write functions of serial communication


#ifndef	 _WIN32SERIAL_H
#define  _WIN32SERIAL_H

#define WIN32_LEAN_AND_MEAN

#include <windows.h>
//#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>
#include <winbase.h>
#include <stdlib.h>
#include <math.h>

// MAPIWIN.H(284):#define INVALID_HANDLE_VALUE        ((HANDLE)(-1))
#define MAX_NUM_COMPORTS 100
#define MAX_RCV_QUEUE 4096

typedef struct 
{
    DCB   dcbCommPort;
    DWORD ComPort;
}RS232_config;



/****************************************************************************
  FUNCTION:  InitComPortConfig()

  PURPOSE:   Set default Com port settings 
			 returns TRUE if sucessful else FALSE

*****************************************************************************/
BOOL InitComPortConfig(RS232_config &sio_cfg, int ComPort, int baudrate=CBR_57600);


/****************************************************************************
  FUNCTION:  GetComPortString()

  PURPOSE:   Returns COM port settings as ascii string 
			 returns ascii string

*****************************************************************************/
TCHAR* GetComPortString(RS232_config sio_cfg);


//G E N E R A L   S E R I A L  R O U T I N E S //////////////////////////////


/****************************************************************************
  FUNCTION:  OpenComPort()

  PURPOSE:   Open a Com port  
			 returns TRUE if sucessful else FALSE

*****************************************************************************/
TCHAR* OpenComPort(HANDLE & hCommPort, RS232_config);

/****************************************************************************
  FUNCTION:  CloseComPort()

  PURPOSE:   Close a Com port and returns TRUE if sucessful. Return FALSE  
			 elswise.
			 returns TRUE if succesful

*****************************************************************************/
BOOL CloseComPort(HANDLE & hCommPort);


/****************************************************************************
  FUNCTION:  ClearTxBuff()

  PURPOSE:   Clear the Driver Tx Buffer 
*****************************************************************************/
BOOL ClearTxBuff(const HANDLE & hCommPort);

/****************************************************************************
  FUNCTION:  WriteComPort()

  PURPOSE:   Write a command to the input buffer. Return the number of character
			 place in the TX buffer.
*****************************************************************************/
DWORD WriteComPort(	const HANDLE & hCommPort,	char *pData, int Len);


#endif//of define _WIN32SERIAL_H
